<?php // redirect too big paged requests to last page of results, respond with 'temporary'.
if ( $paged > $wp_query->max_num_pages ) {
	wp_redirect( preg_replace('/page\/?([0-9]{1,})\/?$/', 'page/'.$wp_query->max_num_pages, $_SERVER["REQUEST_URI"]), 307 );
}

if ( is_singular() || !have_posts() ) {
	get_header('singular');
}
else {
	get_header('generic');
}

if ( have_posts() ) {

	if ( is_home() || is_date() ) {
		$previous_post_datetime = false;
		the_post();
		if ( is_paged() ) {
			$previous_post_datetime = $GLOBALS['darklock']->get_next_post_datetime();
		}
		else if ( is_archive() ) {
			$previous_post_datetime = $GLOBALS['darklock']->get_next_post_datetime_archive();
		}

		$GLOBALS['darklock']->microposts($previous_post_datetime);
		$previous_post_datetime = get_the_time('Y-m-d H:i:s');

		?><div class="<?php echo $GLOBALS['darklock']->get_first_category(); ?>"><?php
		$GLOBALS['darklock']->post();
		$GLOBALS['darklock']->comments_template($template = '/main-comments.php', $form = true);
		?></div><?php
		while ( have_posts() ) {
			the_post();
			$GLOBALS['darklock']->microposts($previous_post_datetime);
			$previous_post_datetime = get_the_time('Y-m-d H:i:s');

			?><div class="<?php echo $GLOBALS['darklock']->get_first_category(); ?>"><?php
			$GLOBALS['darklock']->post();
			$GLOBALS['darklock']->comments_template($template = '/main-comments.php');
			?></div><?php
		}
	}
	else {
		if ( is_singular() ) {
			while ( have_posts() ) {
				the_post();
				?><div class="<?php echo $GLOBALS['darklock']->get_first_category(); ?>"><?php
				$GLOBALS['darklock']->post_singular();
				$GLOBALS['darklock']->comments_template($template = '', $form = true);
				?></div><?php
			}
		}
		else {
			while ( have_posts() ) {
				the_post();
				?><div class="<?php echo $GLOBALS['darklock']->get_first_category(); ?>"><?php
				$GLOBALS['darklock']->post();
				$GLOBALS['darklock']->comments_template($template = '/main-comments.php', $form = true);
				?></div><?php
			}
		}
	}
}
else {
	global $wp_query, $s;
	$wp_query->parse_query();
	$wp_query->is_404 = true;
	$wp_query->is_singular = true;
	?><div class="<?php echo $GLOBALS['darklock']->get_first_category(); ?>"><?php
	if ( $s ) {
		$wp_query->is_search = true;
		$GLOBALS['darklock']->post_404();
	}
	else {
		if ( !get_query_var('name') ) {
			$wp_query->is_archive = true;
		}
		$GLOBALS['darklock']->post_404();
		$GLOBALS['darklock']->comments_template();
	}
	?></div><?php
}

if ( is_singular() || !have_posts() ) {
	get_footer('singular');
}
else {
	get_footer('generic');
}

?>
