// http://wordpress.org/extend/plugins/ajax-comment-posting/
// http://wordpress.org/support/topic/plugin-ajax-comment-posting-duplicate-script-loading-bug-fix?replies=1
jQuery(document).ready(function() {
	/* acp_lang[]:
	   [0]: 'Loading...'
	   [1]: 'Please enter your name.'
	   [2]: 'Please enter your email address.'
	   [3]: 'Please enter a valid email address.'
	   [4]: 'Please enter your comment'
	   [5]: 'Your comment has been added.'
	   [6]: 'ACP error!'
	*/

	// initialise
	jQuery.ajaxSetup ({  
		cache: false  
	}); 
	var form, err, reply;
	function acp_initialise() {
		jQuery('#submit-container').after('<div id="error"></div>');
		//jQuery('#commentform').after('<div id="ccaptcha"></div>');
		jQuery('#submit').before('<img width="16" height="16" src="'+spinner+'" id="comment-loading" alt="'+acp_lang[0]+'" />');
		jQuery('#comment-loading').hide();
		form = jQuery('#commentform');
		err = jQuery('#error');
		reply = false;
	}
	acp_initialise();

	jQuery('.comment-reply-link').live('click', function() {
		// checks if it's a reply to a comment
	        reply = jQuery(this).parents('.depth-1').attr('id');
		err.empty();
	    });

	jQuery('#cancel-comment-reply-link').live('click', function() {
		reply = false;
	    });	
	
        jQuery('#commentform').live('submit', function(evt) {

		err.empty();
    
/*
		if(form.find('#author')[0]) {
		    // if not logged in, validate name and email
		    if(form.find('#author').val() == '') {
			err.html('<span class="error">'+acp_lang[1]+'</span>');
			return false;
		    }
		    if(form.find('#email').val() == '') {
			err.html('<span class="error">'+acp_lang[2]+'</span>');
			return false;
		    }
		    var filter  = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
		    if(!filter.test(form.find('#email').val())) {
			err.html('<span class="error">'+acp_lang[3]+'</span>');
			if (evt.preventDefault) {evt.preventDefault();}
			return false;
		    }
		} // end if
*/
		if(form.find('#comment').val() == '') {
			err.html('<span class="error">'+acp_lang[4]+'</span>');
			return false;
		}

		jQuery(this).ajaxSubmit({
			
			beforeSubmit: function() {
				jQuery('#comment-loading').show();
				jQuery('#submit').attr('disabled','disabled');
			}, // end beforeSubmit
		    
			error: function(request){
				err.empty();
				var data = request.responseText.match(/<p>(.*)<\/p>/);
				err.html('<span class="error">'+ data[1] +'</span>');
				jQuery('#comment-loading').hide();
				jQuery('#submit').removeAttr("disabled");
				return false;
			}, // end error()
		    
			success: function(data) {
				try {
					var id = form.parents('div').find('.post').attr('id');
					var lastDash = id.lastIndexOf('-');
					var postId = id.substring(lastDash+1);
					var commentsBegin = '<!-- BEGIN comments-'+postId+' -->';
					var commentsEnd = '<!-- END comments-'+postId+' -->';

					var response = data.split(commentsBegin);
					response = response[1].split(commentsEnd);
					response = response[0];

					var nOfComments = form.parents('div').find('.n-of-comments');
					nOfComments.html(  parseInt( nOfComments.html() ) + 1  );

					var comments = form.parents('.response').find('.comments');
					var placeHolder = comments.find('.comment-placeholder');
					var newComments = jQuery('<div>');
					newComments.html(String(response));

					var lastComment = comments.find('div.comment:last');
					var lastCommentId = lastComment.find('.comment').attr('id');
					var newComment = newComments.find('div.comment:last');
					var newCommentId = newComment.find('.comment').attr('id');
//alert("lid = "+lastCommentId+", nid = "+newCommentId);
					if (lastCommentId == newCommentId) {
					// akismet ate my comment!
						throw(acp_lang[6]);
					}
					else {
						placeHolder.before('<div>'+newComment.html()+'</div>');
						var newLastComment = comments.find('div:last');
						if(typeof commentPermalinkSlider == 'function') {
							var lastScroller = newLastComment.find('a.comment-permalink-scroller');
							lastScroller.click(commentPermalinkSlider);
						}
						form.find('#comment').val('');
						err.empty();
						jQuery('#submit').removeAttr("disabled");
						jQuery('#comment-loading').hide();
						jQuery("#commenting-fieldset-collapsible").collapse(250, function() {
							var target_offset = newLastComment.offset();
							var target_top = target_offset.top;
							jQuery('html, body').animate({scrollTop:target_top}, 500);
						});
					}


				} catch (e) {
					var error = e;
					if (e != acp_lang[6]) {
						error = acp_lang[7] + ': ' + e.message;
					}
					jQuery('#comment-loading').hide();
					jQuery('#submit').removeAttr("disabled");
					err.html('<span class="error">'+ error +'</span>');
				} // end try
					   
			} // end success()

		}); // end ajaxSubmit()
		
		return false; 
		
	    }); // end form.submit()

});

