// http://hughevans.net/2008/05/28/jquery-toggler
// https://beski.wordpress.com/2009/04/21/scroll-effect-with-local-anchors-jquery/
// http://michael.theirwinfamily.net/articles/jquery/collapsible-fieldsets-jquery-plugin-drupal-style

var commentPermalinkSlider = function(event) {
	if (event.which == '2') {
		return;
	}
	event.preventDefault();

	var id = jQuery(this).attr('id');
	var lastDash = id.lastIndexOf('-');
	var commentId = id.substring(lastDash+1);

	var target = jQuery('#comment-'+commentId);
	var target_offset = target.offset();
	var target_top = target_offset.top;
	jQuery('html, body').animate({scrollTop:target_top}, 500);
	return false;

}

jQuery(document).ready(function() {

	// collapse 'collapsed' elements on load
	jQuery('.collapsed').collapse();

	// toggle collapsible elements with legend collapsers
	var legendCollapser = function(event) {
		if (event.which == '2') {
			return;
		}
		event.preventDefault();

		var collapsible = jQuery(this).parents('.collapsible');
		collapsible.toggleCollapse(250, function() {
			var target_offset;
			if ( collapsible.hasClass('collapsed') ) {
				var target = collapsible.parents('div').find('.feedback-control');
				target_offset = target.offset();
			}
			else {
				target_offset = collapsible.offset();
			}
			var target_top = target_offset.top;
			jQuery('html, body').animate({scrollTop:target_top}, 500);
		});
		return false;
	}
	jQuery('.collapser').click(legendCollapser);


	// http://beckelman.net/post/2008/11/04/Right-or-Left-Click-Context-Menu-Using-jQuery-Demo.aspx
	function getFirstCategory(post) {
		var category = false;
		var categories = jQuery(post).attr('class').split(' ');
		categories.forEach(function(cat) {
			if (cat.indexOf('category-') == 0) {
				category = cat.substring(9);
			}
		});
		return category
	}
	jQuery('.micropost h1').before('<img src="'+xit+'" width="10" height="10" class="hider" alt="'+xit_alt+'" title="'+xit_micropost_title+'" />');
	jQuery('.fullpost header').each(function() {
		var category = getFirstCategory(jQuery(this).parents('.post'));
		if ( !category ) {
			hide_category_title = xit_category_title;
		}
		else if ( category == unhidable_category ) {
			hide_category_title = xit_customize;
		}
		else {
			hide_category_title = xit_hide_category.replace('%s',category);
		}

		jQuery(this).before('<img src="'+xit+'" width="10" height="10" class="hider" alt="'+xit_alt+'" title="'+hide_category_title+'" />');
	});
	jQuery('.hider').hide();
	jQuery('.post').hover(
		function(event) {
			jQuery(this).find('.hider').show();
		},
		function (event) {
			jQuery(this).find('.hider').hide();
		}
	);
	jQuery('.hider').each(function() {
		jQuery(this).contextMenu(
			{
				leftButton: true,
				menu: 'hidemenu',
				hiderTitle: jQuery(this).attr('title')
			},
			function (action, el, pos) {
				switch (action) {
					case "hide": {
						var category = getFirstCategory(jQuery(el).parents('.post'));
						jQuery.cookie(category+'_hidden', 'hidden', { expires: 365 });
						//location.reload();
						jQuery('.category-'+category).addClass('hidden');
						jQuery('#darklock-show-'+category).attr('checked', false);
						break;
					}
					case "customize": {
						//Popup Insert Dialog- included in demo and in download

						jQuery( "#customize-form" ).dialog( "open" );
						break;
					}
				}
			}
		);
	});

	var dialog_buttons = {};
	dialog_buttons[customize_close] = function(){ jQuery( this ).dialog( "close" ); }
	jQuery('.darklock-show').click(function(e) {
		var category = jQuery(this).attr('value');
		if (jQuery(this).attr('checked') == 'checked') {
		// checked = wants to be shown -> unset cookie and show
			jQuery.cookie(category+'_hidden', null);
			jQuery('.category-'+category).removeClass('hidden');
		}
		else {
		// unchecked = wants to be hidden -> set cookie and hide
			jQuery.cookie(category+'_hidden', 'hidden', { expires: 365 });
			jQuery('.category-'+category).addClass('hidden');
		}
	});
	jQuery( "#customize-form" ).dialog({
		autoOpen: false,
		height: 300,
		width: 350,
		modal: true,
		buttons: dialog_buttons,
		open: function() {
		},
		close: function() {
		}
	});


	// hide all togglable elements on load
	jQuery('.togglable').hide();

	// turn comment and post permalinks to sliding links
	jQuery('a.comment-permalink-scroller').click(commentPermalinkSlider);
	jQuery('article header a[rel="bookmark"],aside a[rel="bookmark"]').click(function(event) {
		if (event.which == '2') {
			return;
		}

		var href = jQuery(this).attr('href');
		var hashIndex = href.lastIndexOf('#');
		if (hashIndex < 0) {
			return;
		}
		var hash = href.substring(hashIndex);
		var target = jQuery(hash);
		if (!target) {
			return;
		}

		event.preventDefault();
		var target_offset = target.offset();
		var target_top = target_offset.top;
		jQuery('html, body').animate({scrollTop:target_top}, 500);

		return true;
	});

	// Toggle a post's comments section's visibility 
	jQuery('a.response-toggler').click(function(event) {
		if (event.which == '2') {
			return;
		}
		event.preventDefault();

		var id = jQuery(this).attr('id');
		var lastDash = id.lastIndexOf('-');
		var postId = id.substring(lastDash+1);

		// hide other posts' open comments sections (if any).
		// this isn't strictly necessary, but a completely empty, open
		// comments section (i.e. one without even the form) is
		// confusing to close manually, as it's visually inseparable
		// from one already closed.
		jQuery('.response').not('#response-container-'+postId).hide();

		// the one we want to toggle, and its commenting form placeholder
		var togglable = jQuery('#response-container-'+postId);
		var commentingPlaceholder = jQuery('#commenting-form-placeholder-'+postId);

		// test to see if the selected placeholder already has the commenting form
		var holderResponseForms = commentingPlaceholder.find('#commenting-form-container');
		if ( holderResponseForms.length == 0 ) {
		// the form is not under the current placeholder, so bring it here. hide it first.

			// the form — only one of these on the page at any one time
			var commentingFormContainer = jQuery('#commenting-form-container');

			jQuery("#commenting-fieldset-collapsible").collapse();
			commentingFormContainer.hide();
			commentingPlaceholder.append(commentingFormContainer);
			var respondLinkComment = commentingPlaceholder.find('.respond-link-holder').html();
			var respondLink = respondLinkComment.replace('<!--','').replace('-->','');
			jQuery('#response-prompt').html(respondLink);
			jQuery('#response-prompt').find('.collapser').click(legendCollapser);
			commentingFormContainer.show();

			// update magic fields with data from current post.
			jQuery('#comment_post_ID').attr('value', postId);
		}

		togglable.toggle(250, function() {
			if(togglable.is(':visible')) {

				// readily expand commenting form if current post has no comments
				if ( togglable.children('.comments').children('div').length == 0 ) {
					jQuery("#commenting-fieldset-collapsible").uncollapse();
				}

				togglable.find('input:visible:enabled:first').focus();

				var target = jQuery(this).parents('div').find('.feedback-control');
				target_offset = target.offset();
				var target_top = target_offset.top;
				jQuery('html, body').animate({scrollTop:target_top}, 500);

			}
			else {
				// collapse the form inside the now collapsed comments section.
				jQuery("#commenting-fieldset-collapsible").collapse();

				var target_offset = jQuery('#post-'+postId).offset();
				var target_top = target_offset.top;
				jQuery('html, body').animate({scrollTop:target_top}, 500);
			}
		});

		return false;

	});
});

jQuery.fn.toggleCollapse = function() {
	var options = {
		delay : (arguments[0] || 250),
		callback : (arguments[1] || function() { return false; })
	}
	var collapsible = jQuery(this);
	if ( collapsible.hasClass('collapsed') ) {
		return collapsible.uncollapse(options.delay, options.callback);
	}
	else {
		return collapsible.collapse(options.delay, options.callback);
	}
}
jQuery.fn.collapse = function() {
	var options = {
		delay : (arguments[0] || 250),
		callback : (arguments[1] || function() { return false; })
	}
	var collapsible = jQuery(this);
	return jQuery.when(collapsible.children().not('legend').each(function() {
		jQuery(this).hide(options.delay, function() {
			jQuery(this).css('display', 'none');
		}); // end hide() callback
	})).done( (collapsible.addClass('collapsed') && options.callback()) ); // end each() callback
};
jQuery.fn.uncollapse = function() {
	var options = {
		delay : (arguments[0] || 250),
		callback : (arguments[1] || function() { return false; })
	}
	var collapsible = jQuery(this);
	return jQuery.when(collapsible.children().not('legend').each(function() {
		jQuery(this).show(options.delay);
	})).done( ( collapsible.removeClass('collapsed') && options.callback()) ); // end each() callback
};

